#ifndef EIGHTPUZZLE_H
#define EIGHTPUZZLE_H

#include "aStar.h"

typedef char Byte;

class eightState: public worldState
{
protected:
	Byte board[3][3];//mapping from board to numbers

	Byte xPos[9];//inverse mapping from numbers to x,y locations on board.
	Byte yPos[9];//this is for faster lookup. but consistency must be maintained.

	static eightState* goal;
	static int heuristic;

	static Byte lut[4][9][9][9];//120,340,560,780
	void generateBoard(int arr1[],int arr2[],int a,int b, int c);
	static void saveLUT();

public:
	void setState(Byte b[3][3]);
	void setCell(int x, int y, int value);
	static void setHeuristic(char* h);

	bool makeMove(Byte x, Byte y);//x E {-1,0,1}, y E {-1,0,1}

	bool getConfiguration();//returns true or false, depending on which
							//disjoint set this board belongs to.
	bool isGoalState();
	static void setGoalState(eightState *s);
	bool isSolvable();

	int getNumOutOfPlace();//simple heuristic
	int getManhattanH();
	int getManhattanPenaltyH();
	int getManhattanPenaltyOldH();
	int getLutH();
	int getBubbleH();

	int getHValue();
	list<worldState *>& generateSuccessors();
	void printState();
	bool isEqual(worldState& w);

	static void loadLUT();
	static void generateLUT();
};

#endif

