package visualise;

import java.awt.Color;
import java.awt.*;

public class Tile {
	
	public static Color colors[];	
	public static int width_2=15;
	
	private int r,d,l,u;//right, left, down, up
	private int x, y;
	
	public Tile(int _r, int _d, int _l, int _u){	
		setTile(_r,_d,_l,_u);
	}
	
	public void setTile(int _r, int _d, int _l, int _u){
		r=_r;
		d=_d;
		l=_l;
		u=_u;
	}
	
	public void setPos(int _x, int _y){
		x=_x;
		y=_y;
	}
	
	public void drawTile(Graphics g){
		Polygon p=new Polygon();
		
		p.addPoint(x, y);
		p.addPoint(x+width_2, y+width_2);
		p.addPoint(x+width_2, y-width_2);
		g.setColor(colors[r-1]);
		g.drawPolygon(p);
		g.fillPolygon(p);
		
		p.reset();
		p.addPoint(x, y);
		p.addPoint(x+width_2, y+width_2);
		p.addPoint(x-width_2, y+width_2);
		g.setColor(colors[d-1]);
		g.drawPolygon(p);
		g.fillPolygon(p);
		
		p.reset();
		p.addPoint(x, y);		
		p.addPoint(x-width_2, y+width_2);
		p.addPoint(x-width_2, y-width_2);
		g.setColor(colors[l-1]);
		g.drawPolygon(p);
		g.fillPolygon(p);	
		
		p.reset();
		p.addPoint(x, y);		
		p.addPoint(x-width_2, y-width_2);
		p.addPoint(x+width_2, y-width_2);
		g.setColor(colors[u-1]);
		g.drawPolygon(p);
		g.fillPolygon(p);
	}
	
	void placeTileInBoard(int startX, int startY, int spacing, int _x, int _y){
		setPos(startX+width_2 + spacing*_x , startY - width_2 -spacing*_y);
	}		
}
